const webpackMerge = require('webpack-merge');
const { name, environment } = require('./package');

module.exports = (angularWebpackConfig, options) => {

    const singleSpaConfig = {
        output: {
            library: `${name}-[name]`,
            libraryTarget: 'umd',
            publicPath: process.env.NODE_ENV == 'prod' ? '/WebApi/uebaMetricsAnalysis/static/dist/' : 'http://localhost:4203/'


        },
        externals: {
            'zone.js': 'Zone',
        }
    };
    const mergedConfig = webpackMerge.smart(angularWebpackConfig, singleSpaConfig);
    return mergedConfig;
};


