import { Pipe, PipeTransform } from '@angular/core';

@Pipe({
  name: 'assetImportance'
})
export class AssetImportancePipe implements PipeTransform {
  transform(value: any, args?: any): any {
    const assetImportance = {
        '1': '次要',
        '2': '普通',
        '3': '重要',
        '4': '关键',
        '5': '核心'
    };
    return assetImportance[value] || value;
  }
}

@Pipe({
    name: 'assetAttribute',
})
export class AassetAttributePipe implements PipeTransform {
    transform(value: any, args?: any): any {
        const assetAttribute = {
            'port': '端口',
            'proto': '协议',
            'service_info': '服务信息',
            'os_info': '系统信息',
            'app_info': '应用信息',
        };
        return assetAttribute[value] || value;
    }
}
