import { Pipe, PipeTransform } from '@angular/core';
/**
 * 如下三种会被转为'-'：
 *     null、undefined、''(空字符串)
 *
 * 注意，数字0不会被转换
 */
@Pipe({
    name: 'aviodNull'
})
export class AviodNullPipe implements PipeTransform {

    transform(value: any): any {
        return (value == null || value === '') ? '--' : value;
    }

}
