import { Pipe, PipeTransform } from '@angular/core';

const Base64: any = (window as any).Base64;
@Pipe({
  name: 'base64'
})
export class Base64Pipe implements PipeTransform {

    transform(value: any, args?: any): any {
      const unbase64Str = Base64.decode(value);
      // return safeStr(unbase64Str); // 过滤特殊字符，乱码
      return unbase64Str;
    }

}
