import { ModuleWithProviders } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { PageNotFoundComponent } from './page-not-found/page-not-found.component';
import { ExceptionComponent } from './exception.component';

const appRoutes: Routes = [
    { path: '404', component: PageNotFoundComponent },
    { path: '', redirectTo: '404', pathMatch: 'full' }
];

export const routerModule: ModuleWithProviders = RouterModule.forChild(appRoutes);
