import { ModuleWithProviders } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { ManageComponent } from './layout/manage/manage.component';

const appRoutes: Routes = [
    {
        path: 'manage',
        component: ManageComponent,
        data: { tag: 'isoc', breadcrumb: '事件运维' },
    },
    {
        path: '',
        pathMatch: 'full',
        redirectTo: 'manage',
    },
    {
        path: '**',
        redirectTo: 'manage',
    },
];

export const configrouterModule: ModuleWithProviders = RouterModule.forChild(
    appRoutes
);
