import { ModuleWithProviders } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

const appRoutes: Routes = [
    {
        path: 'config',
        loadChildren: './config/config.module#ConfigModule',
        data: { tag: 'isoc', breadcrumb: '运维配置' },
    },
    {
        path: '',
        loadChildren: './config/config.module#ConfigModule',
    },
];

export const routerModule: ModuleWithProviders = RouterModule.forChild(
    appRoutes
);
