/**
 * 截图字符串：中文长度为2， 其他长度为1
 * value： 字符串
 * maxLength: 最大长度
 */

export const judgeStringLen = (value, maxLength) => {
    let len = 0;
    let temp = '';
    for (let i = 0; i < value.length; i++) {
        if (value.charCodeAt(i) > 127 || value.charCodeAt(i) === 94) {
            len += 2;
        } else {
            len++;
        }
        if (len === maxLength - 1 || len === maxLength - 2) {
            temp = value.substr(0, i);
        }
        if (len >= maxLength) {
            value = temp + '...';
            break;
        }
    }
    return value;
};
