import { Pipe, PipeTransform } from '@angular/core';
/**
 *  (xxxx)xxxxx转换为xxxxx(xxxx)
 *
 */
@Pipe({
  name: 'reverseIpName'
})
export class ReverseIpNamePipe implements PipeTransform {

  transform(value: any): any {
    console.log(value);
    const rgx: RegExp = /^\(.*\).*$/g;
    if (rgx.test(value)) {
        const arr: any[] = value.split(/\(|\)/g);
        return `${arr[2]}(${arr[1]})`;
    } else {
        return value;
    }
  }

}
