import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { PageNotFoundComponent } from './page-not-found/page-not-found.component';
import { routerModule } from './exception.routing';
import { SharedModule} from '../common-ui';
import { ExceptionComponent } from './exception.component';

@NgModule({
  declarations: [PageNotFoundComponent, ExceptionComponent],
  imports: [
    CommonModule,
    routerModule,
    SharedModule
  ]
})
export class ExceptionModule { }
